// RaisePriority.cpp : Defines the entry point for the DLL application.
//

#include "stdafx.h"
#include "lsapi.h"
#include "strsafe.h"

#define V_AUTHOR "thegeek"
#define V_NAME "RaisePriority"
#define V_VERSION "0.1"

HINSTANCE hInstance;
HWND messageHandler;

int lsMessages[] = {
	LM_GETREVID,
	0
};

LRESULT WINAPI MessageHandlerProc(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam)
{
	switch(message)
	{
		case LM_GETREVID:
		{
			UINT uLength;
			StringCchPrintf((char*)lParam, 64, "%s.dll: %s", V_NAME, V_VERSION);
			
			if (SUCCEEDED(StringCchLength((char*)lParam, 64, &uLength)))
				return uLength;

			lParam = NULL;
			return 0;
		}
	}

	return DefWindowProc(hWnd, message, wParam, lParam);
}


BOOL __stdcall _DllMainCRTStartup(HINSTANCE hInst, DWORD fdwReason, LPVOID lpvRes)
{
	// We don't need thread notifications for what we're doing.  Thus, get
	// rid of them, thereby eliminating some of the overhead of this DLL
	DisableThreadLibraryCalls(hInst);

	return TRUE;
}




int initModuleEx(HWND hParent, HINSTANCE hInstance, const char *lsPath)
{
	WNDCLASSEX wc;

	wc.cbSize = sizeof(WNDCLASSEX);
	wc.style = CS_GLOBALCLASS;
	wc.lpfnWndProc = MessageHandlerProc;
	wc.cbClsExtra = 0;
	wc.cbWndExtra = 0;
	wc.hInstance = hInstance;
	wc.hbrBackground = 0;
	wc.hCursor = 0;
	wc.hIcon = 0;
	wc.lpszMenuName = 0;
	wc.lpszClassName = "RaisePriorityMessageHandler";
	wc.hIconSm = 0;

	RegisterClassEx(&wc);

	messageHandler = CreateWindowEx(WS_EX_TOOLWINDOW,
		"RaisePriorityMessageHandler",
		0,
		WS_POPUP,
		0, 0, 0, 0, 
		0,
		0,
		hInstance,
		0);

	if (!messageHandler) 
		return 1;

	SendMessage(GetLitestepWnd(),
		LM_REGISTERMESSAGE,
		(WPARAM) messageHandler,
		(LPARAM) lsMessages);


	//AddBangCommand("!xWindowAlwaysOnTop", BangAlwaysOnTop);
	//AddBangCommand("!xWindowHide", BangHide);


	HWND litestepWND = GetLitestepWnd();

	DWORD   dwProcessId;
	GetWindowThreadProcessId(litestepWND, &dwProcessId);
	HANDLE hProcess = OpenProcess(PROCESS_SET_INFORMATION, false, dwProcessId);
	SetPriorityClass(hProcess, ABOVE_NORMAL_PRIORITY_CLASS);


	return 0;
}

void quitModule(HINSTANCE hInstance)
{
	//RemoveBangCommand("!xWindowAlwaysOnTop");
	//RemoveBangCommand("!xWindowHide");

	SendMessage(GetLitestepWnd(),
		LM_UNREGISTERMESSAGE,
		(WPARAM) messageHandler,
		(LPARAM) lsMessages);

	DestroyWindow(messageHandler);

	UnregisterClass("RaisePriorityMessageHandler", hInstance);

}

